## hugin 2010.2.0+dfsg~rc2

=== CMakeLists.txt ===

# require at least cmake 2.6
cmake_minimum_required(VERSION 2.6 FATAL_ERROR )

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/CMakeModules )

include(HuginMacros)
include(CheckIncludeFiles)

##  global setup
project(hugin)

# version
set(V_MAJOR 2010)
set(V_MINOR 2)
set(V_PATCH 0)

#
# Check for mercurial and get current revision
#

IF(EXISTS ${PROJECT_SOURCE_DIR}/.hg)
  FIND_PROGRAM(_hg hg)
  IF(NOT ${_hg} MATCHES "-NOTFOUND")
    EXECUTE_PROCESS(COMMAND ${_hg} summary WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}" OUTPUT_VARIABLE _release OUTPUT_STRIP_TRAILING_WHITESPACE)
    foreach(_v_l ${_release})
      if(_v_l MATCHES "^.*: *[^0-9]*\([0-9]+\):\([a-z0-9]+\)")
        set(CPACK_PACKAGE_VERSION_PATCH ${CMAKE_MATCH_1})
        set(HUGIN_WC_REVISION ${CMAKE_MATCH_2})
      endif()
    endforeach()
  ELSE()
    SET(HUGIN_WC_REVISION 0)
  ENDIF()
  SET(HUGIN_PACKAGE_VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH})
  SET(HUGIN_DEVELOPMENT_VERSION 1)
  FILE(WRITE ${PROJECT_SOURCE_DIR}/rev.txt "${HUGIN_WC_REVISION}")
  MESSAGE("-- Current HG revision is ${HUGIN_WC_REVISION}")
ELSE()
  IF (EXISTS ${PROJECT_SOURCE_DIR}/.svn)
    # comment out the following line to compile an old version from the subversion repository
    MESSAGE(FATAL_ERROR "Hugin subversion repository is not up to date. The development happens now in mercurial repository. Please switch to mercurial. Sorry for the inconsistency")
  ENDIF()

  SET(HUGIN_PACKAGE_VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH})
  SET(HUGIN_WC_REVISION 0)
  FILE(READ "${PROJECT_SOURCE_DIR}/rev.txt" HUGIN_WC_REVISION)
  MESSAGE("-- Current HG revision is ${HUGIN_WC_REVISION}")
  MESSAGE("-- Assuming this is a tarball (release) build for ${HUGIN_PACKAGE_VERSION}")
  SET(HUGIN_DEVELOPMENT_VERSION 0)
ENDIF()

#
# Check for mercurial and update changelog
#
IF (EXISTS ${PROJECT_SOURCE_DIR}/.hg)
  IF (UPDATE_CHANGELOG)
   FIND_PROGRAM(_hg hg)
   EXECUTE_PROCESS(COMMAND ${_hg} log --follow --style=changelog
   WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
   OUTPUT_FILE ${PROJECT_SOURCE_DIR}/ChangeLog)
   MESSAGE("-- New ChangeLog generated")
  ENDIF (UPDATE_CHANGELOG)
ENDIF (EXISTS ${PROJECT_SOURCE_DIR}/.hg)

# version to display
IF (HUGIN_DEVELOPMENT_VERSION EQUAL 1)
  set(DISPLAY_VERSION "Pre-Release ${V_MAJOR}.${V_MINOR}.${V_PATCH}.${HUGIN_WC_REVISION}")
ELSE (HUGIN_DEVELOPMENT_VERSION EQUAL 1)
  set(DISPLAY_VERSION "${V_MAJOR}.${V_MINOR}.${V_PATCH}.${HUGIN_WC_REVISION}")
ENDIF (HUGIN_DEVELOPMENT_VERSION EQUAL 1)

# version for internal libraries.
set(HUGIN_LIB_VERSION 0.0)

# set include path for internal libraries before using finding and initializing
# external dependencies. This makes sure that "our" include paths are specified
# before any system includes

include_directories( ${CMAKE_BINARY_DIR}/src )
include_directories( ${CMAKE_SOURCE_DIR}/src/hugin_base )
include_directories( ${CMAKE_SOURCE_DIR}/src/foreign )
include_directories( ${CMAKE_SOURCE_DIR}/src/foreign/vigra )
include_directories( ${CMAKE_SOURCE_DIR}/src/celeste )
include_directories( ${CMAKE_BINARY_DIR}/src/celeste )
include_directories( ${CMAKE_SOURCE_DIR}/src )

# this function is not available on some systems, notably FreeBSD and Windows
include(CheckFunctionExists)
set(CMAKE_REQUIRED_LIBRARIES -lm)
check_function_exists(log2 HAVE_LOG2)
# use messages only for debug - on Windows they are extremely intrusive
# message("LOG2 ${HAVE_LOG2}")

IF (EXISTS ${PROJECT_SOURCE_DIR}/.svn)
  IF (UPDATE_CHANGELOG)
    EXECUTE_PROCESS(COMMAND "svn2cl" "--group-by-day" "--include-rev" "--linelen=78"
      "--output=${PROJECT_SOURCE_DIR}/ChangeLog" "${PROJECT_SOURCE_DIR}" )
  ENDIF (UPDATE_CHANGELOG)
ENDIF (EXISTS ${PROJECT_SOURCE_DIR}/.svn)


#
# find dependencies
#
IF (UNIX)
FIND_PACKAGE(PkgConfig)
ENDIF (UNIX)

IF(WIN32)
    set(HUGIN_SHARED "0" CACHE STRING "Build shared internal libraries" )
ELSE(WIN32)
    set(HUGIN_SHARED "1" CACHE STRING "Build shared internal libraries" )
ENDIF(WIN32)

#
# Setup windows search paths for dependencies
#
IF (WIN32)
  ##
  ## The directory that contains the hugin source root is a good
  ## place to look for support packages, so post it in cache.
  ## 
  ## Our FIND_PACKAGE calls modules will search SOURCE_BASE_DIR
  ## after the local standard places  
  ##
  # extract pathname from CMAKE_SOURCE_DIR (note result must be a local var)
  STRING( REGEX REPLACE "(.*)/[^/]+$" "\\1" work "${CMAKE_SOURCE_DIR}" )
  # create the cache entry
  SET( SOURCE_BASE_DIR ${work} CACHE FILEPATH "parent dir of hugin source root" )

  # wxWidgets
  IF(NOT wxWidgets_ROOT_SUFFIX)
    SET( wxWidgets_ROOT_SUFFIX 2.8.10 CACHE STRING "version of wxWidgets." FORCE )
  ENDIF(NOT wxWidgets_ROOT_SUFFIX)

  SET(wxWidgets_ROOT_DIR ${SOURCE_BASE_DIR}/wxWidgets-${wxWidgets_ROOT_SUFFIX})
  # GLEW moved to FildGLEW.cmake module
  # SET(GLEW_INCLUDE_DIR ${SOURCE_BASE_DIR}/glew/include)
  # for dynamic build, it's glew32.lib and the dll must be copied into hugin's bin folder
  # SET(GLEW_LIBRARIES ${SOURCE_BASE_DIR}/glew/lib/glew32s.lib)
ENDIF(WIN32)

##
## wxWidgets
##
#  This must come before FINDs for tiff, jpeg, png, zlib to enable
#  finding the wxWidgets distributions of those packages (Win32 only).

SET(wxWidgets_USE_LIBS base core xrc html xml adv gl net)
FIND_PACKAGE(wxWidgets REQUIRED)

# hugin requires wxwidgets 2.7.0 or above
IF (UNIX)
  EXEC_PROGRAM(sh ARGS "${wxWidgets_CONFIG_EXECUTABLE} --version" OUTPUT_VARIABLE wxWidgets_VERSION)
  STRING(REGEX REPLACE "^([0-9]+\\.[0-9]+)\\..*" "\\1"  wxWidgets_VERSION ${wxWidgets_VERSION})
  IF(wxWidgets_VERSION STREQUAL "2.5")
    SET(wxWidgets_FOUND FALSE)
    MESSAGE("wxWidgets 2.5.x not supported")
  ENDIF(wxWidgets_VERSION STREQUAL "2.5")
  IF(wxWidgets_VERSION STREQUAL "2.6")
    SET(wxWidgets_FOUND FALSE)
    MESSAGE("wxWidgets 2.6.x not supported")
  ENDIF(wxWidgets_VERSION STREQUAL "2.6")
ENDIF (UNIX)

IF(NOT wxWidgets_FOUND)
  MESSAGE("wxWidgets was not found, GUI programs (hugin, nona_gui) disabled")
ENDIF(NOT wxWidgets_FOUND) 

##
## Graphics libraries
##
# wxWidgets sub-packages will be used if native ones aren't found

FIND_PACKAGE(TIFF REQUIRED)
INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
FIND_PACKAGE(JPEG REQUIRED)
INCLUDE_DIRECTORIES(${JPEG_INCLUDE_DIR})
FIND_PACKAGE(PNG REQUIRED)
INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})

FIND_PACKAGE(OpenEXR REQUIRED)
include_directories(${OPENEXR_INCLUDE_DIR})

FIND_PACKAGE(Exiv2 REQUIRED)
INCLUDE_DIRECTORIES(${EXIV2_INCLUDE_DIR})

## OpenGL and GLEW

FIND_PACKAGE(OpenGL)
FIND_PACKAGE(GLUT)
FIND_PACKAGE(GLEW)
IF(NOT OPENGL_FOUND)
  MESSAGE("OpenGL was not found, hugin disabled")
ENDIF(NOT OPENGL_FOUND)
IF(GLEW_FOUND)
  INCLUDE_DIRECTORIES(${OPENGL_INCLUDE_DIR})
  INCLUDE_DIRECTORIES(${GLUT_INCLUDE_DIR})
  INCLUDE_DIRECTORIES(${GLEW_INCLUDE_DIR})
ENDIF(GLEW_FOUND)

##
## Panotools
##

FIND_PACKAGE(PANO13 2.9.17 REQUIRED)

IF(PANO13_FOUND)
  SET(PANO_LIBRARIES ${PANO13_LIBRARIES})
  SET(PANO_INCLUDE_DIR ${PANO13_INCLUDE_DIR})
ELSE(PANO13_FOUND)
  MESSAGE(SEND_ERROR "libpano13 required")
ENDIF(PANO13_FOUND) 
INCLUDE_DIRECTORIES(${PANO_INCLUDE_DIR})

##
## Boost
##
# I am sick of having to edit the boost rev number in this file.
# Now it is a cache variable you can edit in cmakesetup --TKS
#
IF( NOT Boost_root_suffix )
  SET( Boost_root_suffix _1_41_0 CACHE STRING "suffix of boost root dir." FORCE )
ENDIF( NOT Boost_root_suffix )

IF(WIN32)
  IF(${HUGIN_SHARED})
    SET(Boost_USE_STATIC_LIBS OFF)
    # ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)
    # ADD_DEFINITIONS(-D_DLL)
    ADD_DEFINITIONS(-DBOOST_ALL_NO_LIB)
  ELSE(${HUGIN_SHARED})
    SET(Boost_USE_STATIC_LIBS ON)
  ENDIF(${HUGIN_SHARED})
  # If BOOST_ROOT was defined in the environment, use it. 
  if (NOT BOOST_ROOT AND NOT $ENV{BOOST_ROOT} STREQUAL "") 
    set(BOOST_ROOT $ENV{BOOST_ROOT}) 
  else(NOT BOOST_ROOT AND NOT $ENV{BOOST_ROOT} STREQUAL "") 
    set(BOOST_ROOT ${SOURCE_BASE_DIR}/boost${Boost_root_suffix}) 
   endif(NOT BOOST_ROOT AND NOT $ENV{BOOST_ROOT} STREQUAL "") 
ENDIF(WIN32)
FIND_PACKAGE(Boost COMPONENTS thread date_time)
IF (NOT Boost_FOUND)
  MESSAGE(FATAL_ERROR "boost not found. Bad BOOST_ROOT? On windows, try editing Boost_root_suffix")
ENDIF (NOT Boost_FOUND)

INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})

FIND_PACKAGE(MSGFMT REQUIRED)
IF(MSGFMT_FOUND)
  MESSAGE(STATUS "Program msgfmt found (${MSGFMT_EXECUTABLE})")
ENDIF(MSGFMT_FOUND)

##
## LAPACK (optional, enable by -DENABLE_LAPACK=ON)
##
OPTION (ENABLE_LAPACK "Use LAPACK based solver in levmar" OFF)

IF(ENABLE_LAPACK)
  FIND_PACKAGE(LAPACK)
  IF(LAPACK_FOUND)
    MESSAGE(STATUS "LAPACK found (${LAPACK_LIBRARIES})")
  ELSE(LAPACK_FOUND)
    MESSAGE(STATUS "LAPACK not found, using LU-based solver")
  ENDIF(LAPACK_FOUND)
ENDIF(ENABLE_LAPACK)

# vips is not used right now
#IF (WIN32)
#  # todo: check for vips (not needed right now)
#ELSE (WIN32)
#  pkg_check_modules(VIPS vips-7.12)
#  LIST2STRING(VIPS_CFLAGS_OTHER VIPS_CFLAGS_OTHER_STRING)
#  LIST2STRING(VIPS_LDFLAGS_OTHER VIPS_LDFLAGS_OTHER_STRING)
#
#  pkg_check_modules(VIPSCC vipsCC-7.12)
#  LIST2STRING(VIPSCC_CFLAGS_OTHER VIPSCC_CFLAGS_OTHER_STRING)
#  LIST2STRING(VIPSCC_LDFLAGS_OTHER VIPSCC_LDFLAGS_OTHER_STRING)
#ENDIF (WIN32)
#INCLUDE_DIRECTORIES( ${VIPSCC_INCLUDE_DIRS} )
#LINK_DIRECTORIES( ${VIPSCC_LIBRARY_DIRS} )

#
# Check build type and set options accordingly
# 
IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

# allow user to specify lib suffix
set(LIB_SUFFIX "" CACHE STRING "Define suffix of lib directory name (32/64)" )

IF(${CMAKE_BUILD_TYPE} STREQUAL "Debug")
  MESSAGE("Building in Debug mode, resulting programs will be SLOW")
  ADD_DEFINITIONS(-DDEBUG)
  IF(UNIX)
    ADD_DEFINITIONS(-Wall)
  ENDIF(UNIX)
ENDIF(${CMAKE_BUILD_TYPE} STREQUAL "Debug")

#
# define destination dirs (relative to prefix)
#
SET(HUGINDATADIR share/hugin)
SET(DATADIR share)
SET(BINDIR  bin)

IF (NOT MANDIR AND NOT $ENV{MANDIR} STREQUAL "")
    SET (MANDIR "$ENV{MANDIR}")
ELSEIF(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD" OR CMAKE_SYSTEM_NAME STREQUAL "NetBSD")
    SET (MANDIR "man")
ELSE(NOT MANDIR AND NOT $ENV{MANDIR} STREQUAL "")
    SET (MANDIR "share/man")
ENDIF(NOT MANDIR AND NOT $ENV{MANDIR} STREQUAL "")

SET(LOCALEDIR share/locale) 
SET(ICONDIR share/icons) 
SET(LINKDIR share/applications)
SET(LIBDIR  lib${LIB_SUFFIX})
SET(INSTALL_XRC_DIR ${CMAKE_INSTALL_PREFIX}/share/hugin/xrc)
SET(INSTALL_DATA_DIR ${CMAKE_INSTALL_PREFIX}/share/hugin/data)

# setup bundle install prefix
IF (APPLE)
  IF (NOT MAC_SELF_CONTAINED_BUNDLE)
    IF (CMAKE_INSTALL_PREFIX STREQUAL "/opt/local")
      # MacPorts
      SET(INSTALL_OSX_BUNDLE_DIR /Applications/MacPorts CACHE DOCSTRING "Install directory Hugin and HuginStitchProject application bundles")
    ELSE(CMAKE_INSTALL_PREFIX STREQUAL "/opt/local")
      # fink or other custom system.
      SET(INSTALL_OSX_BUNDLE_DIR ${CMAKE_INSTALL_PREFIX}/Applications CACHE DOCSTRING "Install directory Hugin and HuginStitchProject application bundles")
    ENDIF(CMAKE_INSTALL_PREFIX STREQUAL "/opt/local")
    MESSAGE("*** Will install application bundles in ${INSTALL_OSX_BUNDLE_DIR}, set INSTALL_OSX_BUNDLE_DIR to change the location")
  ENDIF (NOT MAC_SELF_CONTAINED_BUNDLE)
ENDIF (APPLE)


IF (UNIX)
  IF (${HUGIN_SHARED})
    # use shared internal libraries
    SET(HUGIN_SHARED_LIBS 1)
  ENDIF (${HUGIN_SHARED})
  MESSAGE("-- Using shared internal libraries")
ELSE (UNIX)

  IF (${HUGIN_SHARED})
    ADD_DEFINITIONS(-DVIGRA_DLL)
    ADD_DEFINITIONS(-DOPENEXR_DLL)
    ADD_DEFINITIONS(-DHugin_shared)
    SET(HUGIN_SHARED_LIBS 1)
  ELSE(${HUGIN_SHARED})
    ADD_DEFINITIONS(-DVIGRA_STATIC_LIB)
  ENDIF(${HUGIN_SHARED})

  # Windows installer packaging related stuff

=== doc/CMakeLists.txt ===

IF (WIN32)
INSTALL(FILES fulla.html DESTINATION doc)
INSTALL(FILES nona.txt DESTINATION doc)
ELSE (WIN32)
INSTALL(FILES align_image_stack.1 autooptimiser.1 celeste_standalone.1
    fulla.1 hugin.1 hugin_hdrmerge.1 hugin_stitch_project.1 nona.1
    nona_gui.1 PTBatcherGUI.1 pto2mk.1 tca_correct.1 vig_optimize.1
    calibrate_lens.1 cpclean.1 deghosting_mask.1 pano_trafo.1
    pano_modify.1 pto_merge.1
    DESTINATION ${MANDIR}/man1)
ENDIF(WIN32)

=== src/CMakeLists.txt ===

# define common sets of libraries, used by different subdirectories
IF (MSVC)
  IF(LAPACK_FOUND)
    # boost_thread is linked automatically
    # additionally link to our getopt
    set(common_libs huginbase hugingetopt
        ${PANO_LIBRARIES} ${LAPACK_LIBRARIES} huginlevmar)
  ELSE(LAPACK_FOUND)
    set(common_libs huginbase hugingetopt
        ${PANO_LIBRARIES} huginlevmar)
  ENDIF(LAPACK_FOUND)
  include_directories( ${CMAKE_SOURCE_DIR}/src/foreign/getopt/include )
ELSE (MSVC)
  IF(LAPACK_FOUND)
    # need to specify boost thread library
    set(common_libs huginbase
        ${Boost_LIBRARIES} ${PANO_LIBRARIES} ${LAPACK_LIBRARIES} ${GLEW_LIBRARIES} huginlevmar)
  ELSE(LAPACK_FOUND)
    # need to specify boost thread library
    set(common_libs huginbase 
        ${Boost_LIBRARIES} ${PANO_LIBRARIES} ${GLEW_LIBRARIES} huginlevmar)
  ENDIF(LAPACK_FOUND)
ENDIF (MSVC)

set(image_libs huginvigraimpex ${OPENEXR_LIBRARIES} ${JPEG_LIBRARIES} ${TIFF_LIBRARIES}
    ${PNG_LIBRARIES} ${ZLIB_LIBRARIES} ${EXIV2_LIBRARIES})

add_subdirectory(celeste)
add_subdirectory(foreign)
add_subdirectory(hugin_base)
add_subdirectory(tools)
add_subdirectory(matchpoint)
add_subdirectory(deghosting)
add_subdirectory(lens_calibrate)

# build vips stuff, only if vips was found
# not ready for the general public yet
IF(VIPS_FOUND)
#  add_subdirectory(vips)
ENDIF(VIPS_FOUND)

# build gui only if wxWidgets was found
IF(wxWidgets_FOUND)
  INCLUDE(${wxWidgets_USE_FILE})
  add_subdirectory(hugin1)

  include_directories( ${CMAKE_SOURCE_DIR}/src/hugin1 )
  # do we need to define _UNICODE on windows?
  IF(WIN32)
    IF ("${wxWidgets_CONFIGURATION}" STREQUAL "mswu")
      ADD_DEFINITIONS("-D_UNICODE")
    ENDIF("${wxWidgets_CONFIGURATION}" STREQUAL "mswu")
  ENDIF(WIN32)
ENDIF(wxWidgets_FOUND)

add_subdirectory(translations)

=== src/celeste/CMakeLists.txt ===
#    Copyright (C) 2008 by Tim Nugent
#    timnugent@gmail.com
# 
#    This file is part of hugin.
# 
#    Hugin is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 2 of the License, or
#    (at your option) any later version.
#  
#    Hugin is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#  
#    You should have received a copy of the GNU General Public License
#    along with Hugin  If not, see <http://www.gnu.org/licenses/>.
 
IF(NOT WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")
ENDIF(NOT WIN32)

# a list of all files belonging to celeste library

SET(CELESTE_SRC
CelesteGlobals.cpp
CelesteGlobals.h
Celeste.cpp
Celeste.h
ContrastFilter.cpp
ContrastFilter.h
Gabor.cpp
Gabor.h
GaborGlobal.h
GaborFilter.cpp
GaborFilter.h
GaborJet.cpp
GaborJet.h
ImageFile.cpp
ImageFile.h
LogPolar.cpp
LogPolar.h
PGMImage.cpp
PGMImage.h
svm.cpp
svm.h
Utilities.cpp
Utilities.h
)

IF (${HUGIN_SHARED_LIBS})
    # messages are quite obtrusive in windows cmakesetup.exe
    IF (NOT WIN32)
	#message("Using these CMAKE_CXX_FLAGS : ${CMAKE_CXX_FLAGS}")
	ENDIF (NOT WIN32)
	ADD_LIBRARY(celeste SHARED ${CELESTE_SRC})
	TARGET_LINK_LIBRARIES(celeste huginbasewx ${common_libs})
	set_target_properties(celeste PROPERTIES VERSION ${HUGIN_LIB_VERSION})
    IF(WIN32)
      install(TARGETS celeste RUNTIME DESTINATION ${BINDIR})
    ELSE(WIN32)
      install(TARGETS celeste DESTINATION ${LIBDIR})
    ENDIF(WIN32)
ELSE (${HUGIN_SHARED_LIBS})
    # messages are quite obtrusive in windows cmakesetup.exe
    IF (NOT WIN32)
    	#message("Using these CMAKE_CXX_FLAGS : ${CMAKE_CXX_FLAGS}")
	ENDIF (NOT WIN32)	
	ADD_LIBRARY(celeste STATIC ${CELESTE_SRC})
	TARGET_LINK_LIBRARIES(celeste huginbasewx ${common_libs})
	set_target_properties(celeste PROPERTIES VERSION ${HUGIN_LIB_VERSION})
ENDIF (${HUGIN_SHARED_LIBS})

# standalone
ADD_EXECUTABLE(celeste_standalone ../hugin_config.h  Main.cpp )
target_link_libraries( celeste_standalone celeste ${image_libs} ${Boost_LIBRARIES} ${wxWidgets_LIBRARIES})

SET (CELESTE_MODEL
	data/celeste.model
)

INSTALL(TARGETS celeste_standalone DESTINATION ${BINDIR}) 
INSTALL(FILES ${CELESTE_MODEL} DESTINATION ${INSTALL_DATA_DIR})

#add_subdirectory(training)

=== src/foreign/CMakeLists.txt ===

add_subdirectory(ANN)
add_subdirectory(vigra)
add_subdirectory(levmar)
add_subdirectory(lensdb)

IF (WIN32 AND NOT MINGW)
  add_subdirectory(getopt)
ENDIF (WIN32 AND NOT MINGW)

=== src/hugin1/CMakeLists.txt ===

include_directories( ${CMAKE_SOURCE_DIR}/src/hugin1 )

# build gui only if wxWidgets was found
IF(wxWidgets_FOUND)
#  INCLUDE(${wxWidgets_USE_FILE})

  # do we need to define _UNICODE on windows?
  IF(WIN32)
    IF ("${wxWidgets_CONFIGURATION}" STREQUAL "mswu")
      ADD_DEFINITIONS("-D_UNICODE")
    ENDIF("${wxWidgets_CONFIGURATION}" STREQUAL "mswu")
  ENDIF(WIN32)

  add_subdirectory(base_wx)
  add_subdirectory(stitch_project)
  # build  Hugin only if OpenGL was found
  IF(OPENGL_FOUND)
    add_subdirectory(hugin)
  ENDIF(OPENGL_FOUND)  
  add_subdirectory(nona_gui)
  add_subdirectory(ptbatcher)
ENDIF(wxWidgets_FOUND)

IF(VIPS_FOUND)
#  add_subdirectory(tools_vips)
ENDIF(VIPS_FOUND)

#add_subdirectory(tools)
#add_subdirectory(tests)

=== src/hugin_base/CMakeLists.txt ===

# a list of all files belonging to hugin base library

# unused sources
# algorithms/external/PTStitcherStitcher.cpp
#algorithms/external/PTmenderStitcher.cpp

SET(HUGIN_BASE_SRC
algorithms/nona/NonaFileStitcher.cpp
algorithms/nona/NonaImageStitcher.cpp
algorithms/basic/CalculateCPStatistics.cpp
algorithms/basic/CalculateMeanExposure.cpp
algorithms/basic/CalculateOptimalScale.cpp
algorithms/basic/CalculateOptimalROI.cpp
algorithms/basic/RotatePanorama.cpp
algorithms/basic/StraightenPanorama.cpp
algorithms/basic/CalculateOverlap.cpp
algorithms/nona/CalculateFOV.cpp
algorithms/nona/CenterHorizontally.cpp
algorithms/nona/FitPanorama.cpp
algorithms/nona/ComputeImageROI.cpp
algorithms/optimizer/ImageGraph.cpp
algorithms/optimizer/PhotometricOptimizer.cpp
algorithms/optimizer/PTOptimizer.cpp
algorithms/panorama_makefile/PanoramaMakefileExport.cpp
algorithms/point_sampler/PointSampler.cpp
algorithms/control_points/CleanCP.cpp
appbase/ExternalProgram.cpp
appbase/ExternalProgramSetup.cpp
appbase/ProgressDisplay.cpp
appbase/ProgressDisplayOld.cpp
appbase/ProgressReporterOld.cpp
huginapp/CachedImageRemapper.cpp
huginapp/ImageCache.cpp
hugin_math/eig_jacobi.cpp
hugin_math/graph.cpp
hugin_math/Matrix3.cpp
hugin_math/Vector3.cpp
hugin_utils/utils.cpp
hugin_utils/platform.cpp
nona/SpaceTransform.cpp
nona/Stitcher1.cpp
nona/Stitcher2.cpp
nona/Stitcher3.cpp
nona/Stitcher4.cpp
nona/Stitcher.cpp
panodata/ControlPoint.cpp
panodata/Lens.cpp
panodata/Mask.cpp
panodata/PanoImage.cpp
panodata/Panorama.cpp
panodata/PanoramaOptions.cpp
panodata/PanoramaVariable.cpp
panodata/PTScriptParsing.cpp
panodata/SrcPanoImage.cpp
panodata/ImageVariableGroup.cpp
panodata/StandardImageVariableGroups.cpp
panotools/PanoToolsInterface.cpp
panotools/PanoToolsOptimizerWrapper.cpp
panotools/PanoToolsUtils.cpp
panotools/PanoToolsTransformGPU.cpp
vigra_ext/emor.cpp
vigra_ext/MultiThreadOperations.cpp
vigra_ext/ImageTransformsGPU.cpp
)

SET(HUGIN_BASE_HEADER
algorithm/PanoramaAlgorithm.h
algorithm/StitcherAlgorithm.h
algorithms/nona/NonaFileStitcher.h
algorithms/nona/NonaImageStitcher.h
algorithms/basic/CalculateCPStatistics.h
algorithms/basic/CalculateMeanExposure.h
algorithms/basic/CalculateOptimalScale.h
algorithms/basic/CalculateOptimalROI.h
algorithms/basic/RotatePanorama.h
algorithms/basic/StraightenPanorama.h
algorithms/basic/CalculateOverlap.h
algorithms/nona/CalculateFOV.h
algorithms/nona/CenterHorizontally.h
algorithms/nona/FitPanorama.h
algorithms/nona/ComputeImageROI.h
algorithms/optimizer/ImageGraph.h
algorithms/optimizer/PhotometricOptimizer.h
algorithms/optimizer/PTOptimizer.h
algorithms/panorama_makefile/PanoramaMakefileExport.h
algorithms/point_sampler/PointSampler.h
algorithms/control_points/CleanCP.h
appbase/ExternalProgram.h
appbase/ExternalProgramSetup.h
appbase/ProgressDisplay.h
appbase/ProgressDisplayOld.h
appbase/ProgressReporterOld.h
huginapp/CachedImageRemapper.h
huginapp/ImageCache.h
hugin_math/eig_jacobi.h
hugin_math/graph.h
hugin_math/Matrix3.h
hugin_math/Vector3.h
hugin_utils/utils.h
hugin_utils/platform.h
nona/ImageRemapper.h
nona/RemappedPanoImage.h
nona/SpaceTransform.h
nona/Stitcher.h
panodata/ControlPoint.h
panodata/Lens.h
panodata/Mask.h
panodata/PanoramaData.h
panodata/PanoImage.h
panodata/Panorama.h
panodata/PanoramaOptions.h
panodata/PanoramaVariable.h
panodata/PTScriptParsing.h
panodata/SrcPanoImage.h
panodata/DestPanoImage.h
panodata/image_variables.h
panodata/ImageVariable.h
panodata/ImageVariableGroup.h
panodata/ImageVariableTranslate.h
panodata/StandardImageVariableGroups.h
panotools/PanoToolsInterface.h
panotools/PanoToolsOptimizerWrapper.h
panotools/PanoToolsUtils.h
vigra_ext/emor.h
vigra_ext/MultiThreadOperations.h
vigra_ext/ImageTransformsGPU.h
)

IF (${HUGIN_SHARED_LIBS})
  add_library(huginbase SHARED ${HUGIN_BASE_SRC} ${HUGIN_BASE_HEADER})
  target_link_libraries(huginbase ${Boost_LIBRARIES})
  set_target_properties(huginbase PROPERTIES VERSION ${HUGIN_LIB_VERSION})
  IF(WIN32)
    install(TARGETS huginbase RUNTIME DESTINATION ${BINDIR})
  ELSE(WIN32)
    install(TARGETS huginbase DESTINATION ${LIBDIR})
  ENDIF(WIN32)
ELSE (${HUGIN_SHARED_LIBS})
  add_library(huginbase STATIC ${HUGIN_BASE_SRC} ${HUGIN_BASE_HEADER})
ENDIF (${HUGIN_SHARED_LIBS})

add_subdirectory(test)

TARGET_LINK_LIBRARIES(huginbase huginlevmar huginvigraimpex
        ${Boost_LIBRARIES} ${EXIV2_LIBRARIES} ${PANO_LIBRARIES}
        ${TIFF_LIBRARIES} ${LAPACK_LIBRARIES} ${GLEW_LIBRARIES}
        ${OPENGL_LIBRARIES} ${GLUT_LIBRARIES})

=== src/lens_calibrate/CMakeLists.txt ===
ADD_EXECUTABLE(calibrate_lens 
Main.cpp
Globals.h
Globals.cpp
MapPoints.h
MapPoints.cpp
ProcessImage.h
ProcessImage.cpp
Straighten.h
Straighten.cpp
lensFunc.h
lensFunc.cpp
HermiteSpline.h
HermiteSpline.c
find_N8_lines.h
find_N8_lines.cpp
)

ADD_EXECUTABLE( test_lensFunc
test_lensFunc.cpp
lensFunc.cpp
HermiteSpline.c
)

TARGET_LINK_LIBRARIES( calibrate_lens huginANN ${image_libs} ${common_libs} )
INSTALL(TARGETS calibrate_lens DESTINATION ${BINDIR})

=== src/tools/CMakeLists.txt ===

add_executable(fulla fulla.cpp)
target_link_libraries(fulla ${common_libs} huginlensdb ${image_libs})

add_executable(nona nona.cpp)
target_link_libraries(nona ${common_libs} ${image_libs} ${OPENGL_LIBRARIES} ${GLUT_LIBRARIES} ${GLEW_LIBRARIES})

#add_executable(autocreate autocreate.cpp)
#target_link_libraries(autocreate ${common_libs} ${image_libs})

add_executable(autooptimiser autooptimiser.cpp ExtractPoints.h)
target_link_libraries(autooptimiser ${common_libs} ${image_libs})

add_executable(vig_optimize vig_optimize.cpp ExtractPoints.h)
target_link_libraries(vig_optimize ${common_libs} ${image_libs})

add_executable(align_image_stack align_image_stack.cpp)
target_link_libraries(align_image_stack ${common_libs} ${image_libs} ${GLEW_LIBRARIES} ${GLUT_LIBRARIES})

add_executable(tca_correct tca_correct.cpp)
target_link_libraries(tca_correct ${common_libs} ${image_libs})

add_executable(pto2mk pto2mk.cpp)
target_link_libraries(pto2mk ${common_libs} ${image_libs} )

add_executable(cpclean cpclean.cpp)
target_link_libraries(cpclean ${common_libs} )

add_executable(pto_merge pto_merge.cpp)
target_link_libraries(pto_merge ${common_libs} )

add_executable(pano_trafo pano_trafo.cpp)
target_link_libraries(pano_trafo ${common_libs} )

add_executable(pano_modify pano_modify.cpp)
target_link_libraries(pano_modify ${common_libs} )

add_executable(hugin_hdrmerge hugin_hdrmerge.cpp ../deghosting/deghosting.cpp ../deghosting/deghosting.h ../deghosting/khan.h ../deghosting/support.h ../deghosting/algtinyvector.h)
target_link_libraries(hugin_hdrmerge ${common_libs} ${image_libs} )

install(TARGETS nona vig_optimize autooptimiser fulla align_image_stack
        tca_correct pto2mk cpclean hugin_hdrmerge pano_trafo pano_modify pto_merge
        DESTINATION ${BINDIR})

=== src/foreign/ANN/CMakeLists.txt ===


SET(ANN_SRC ANN.cpp brute.cpp kd_tree.cpp kd_util.cpp kd_split.cpp
            kd_dump.cpp kd_search.cpp kd_pr_search.cpp kd_fix_rad_search.cpp
            bd_tree.cpp bd_search.cpp bd_pr_search.cpp bd_fix_rad_search.cpp
	    perf.cpp)

SET(ANN_HEADERS ANN.h ANNperf.h ANNx.h kd_tree.h kd_split.h kd_util.h kd_search.h
                 kd_pr_search.h kd_fix_rad_search.h pr_queue.h pr_queue_k.h)


IF (${HUGIN_SHARED_LIBS})
  add_library(huginANN SHARED ${ANN_SRC} ${ANN_HEADERS})
  set_target_properties(huginANN PROPERTIES VERSION ${HUGIN_LIB_VERSION})
  IF(WIN32)
    install(TARGETS huginANN RUNTIME DESTINATION ${BINDIR})
  ELSE(WIN32)
    install(TARGETS huginANN DESTINATION ${LIBDIR})
  ENDIF(WIN32)
ELSE (${HUGIN_SHARED_LIBS})
  add_library(huginANN STATIC ${ANN_SRC} ${ANN_HEADERS})
ENDIF (${HUGIN_SHARED_LIBS})

=== src/hugin1/base_wx/CMakeLists.txt ===

SET(HUGIN_WX_BASE_SRC ImageCache.cpp MyProgressDialog.cpp Plot2D.cpp PTWXDlg.cpp
                      huginConfig.cpp MyExternalCmdExecDialog.cpp platform.cpp
                      RunStitchPanel.cpp )
SET(HUGIN_WX_BASE_HEADER ImageCache.h MyProgressDialog.h Plot2D.h PTWXDlg.h
                      huginConfig.h MyExternalCmdExecDialog.h platform.h
                      RunStitchPanel.h )


IF (${HUGIN_SHARED_LIBS})
  add_library(huginbasewx SHARED ${HUGIN_WX_BASE_SRC} ${HUGIN_WX_BASE_HEADER})
  target_link_libraries(huginbasewx ${wxWidgets_LIBRARIES} huginbase ${common_libs})
  set_target_properties(huginbasewx PROPERTIES VERSION ${HUGIN_LIB_VERSION})
  IF(WIN32)
    install(TARGETS huginbasewx RUNTIME DESTINATION ${BINDIR})
  ELSE(WIN32)
    install(TARGETS huginbasewx DESTINATION ${LIBDIR})
  ENDIF(WIN32)
ELSE (${HUGIN_SHARED_LIBS})
  add_library(huginbasewx STATIC ${HUGIN_WX_BASE_SRC} ${HUGIN_WX_BASE_HEADER})
ENDIF (${HUGIN_SHARED_LIBS})

=== src/hugin1/hugin/CMakeLists.txt ===
# Application name
IF(APPLE)
  set( PROGNAME Hugin )
  set( MACOSX_BUNDLE_EXTENSION pto)
  set( MACOSX_BUNDLE_ICON_FILE Hugin.icns )
  set( MACOSX_BUNDLE_TYPE_ICON_FILE HuginFiles.icns )
  set( MACOSX_BUNDLE_MIME_TYPE application/x-ptoptimizer-script )
  set( MACOSX_BUNDLE_TYPE_NAME "Hugin Project" )
  set( MACOSX_BUNDLE_TYPE_ROLE Editor )
  set( MACOSX_BUNDLE_VERSION ${V_MAJOR}.${V_MINOR}.${V_PATCH} )
  set( MACOSX_BUNDLE_SHORT_VERSION_STRING ${MACOSX_BUNDLE_VERSION})
  set( MACOSX_BUNDLE_LONG_VERSION_STRING "Version ${MACOSX_BUNDLE_VERSION}" )
  set( MACOSX_BUNDLE_GUI_IDENTIFIER net.sourceforge.hugin)
  set( MACOSX_BUNDLE_INFO_STRING "Hugin ${MACOSX_BUNDLE_VERSION}" )
  set( MACOSX_BUNDLE_BUNDLE_NAME "Hugin" )
  set( MACOSX_BUNDLE_COPYRIGHT "Copyright 2007 Pablo d'Angelo" )
  set( MACOSX_BUNDLE_SIGNATURE "Hgin" )
  #  set( CMAKE_OSX_ARCHITECTURES ppc;i386 ) #Comment out if not universal binary
ELSE(APPLE)
  set( PROGNAME hugin )
ENDIF(APPLE)

# sources
set(hugin_SOURCES
huginApp.cpp ImagesList.cpp AutoCtrlPointCreator.cpp CPDetectorConfig.cpp 
MainFrame.cpp CPImageCtrl.cpp CPImagesComboBox.cpp CPEditorPanel.cpp LensPanel.cpp 
ImagesPanel.cpp CommandHistory.cpp PanoPanel.cpp NonaOptionsDialog.cpp HDRMergeOptionDialog.cpp
PreviewFrame.cpp PreviewPanel.cpp GLPreviewFrame.cpp GLViewer.cpp GLRenderer.cpp NumTransDialog.cpp
CropPanel.cpp OptimizePhotometricPanel.cpp OptimizePanel.cpp CPListFrame.cpp
TextKillFocusHandler.cpp PreferencesDialog.cpp ResetDialog.cpp
LocalizedFileTipProvider.cpp  wxPanoCommand.cpp AssistantPanel.cpp
HFOVDialog.cpp TextureManager.cpp MeshRemapper.cpp VertexCoordRemapper.cpp
TexCoordRemapper.cpp ChoosyRemapper.cpp MeshManager.cpp ViewState.cpp
OutputProjectionInfo.cpp PreviewToolHelper.cpp PreviewTool.cpp 
PreviewCropTool.cpp PreviewDragTool.cpp PreviewIdentifyTool.cpp
PreviewDifferenceTool.cpp PreviewPanoMaskTool.cpp PreviewControlPointTool.cpp
GreatCircles.cpp AboutDialog.cpp LayoutRemapper.cpp PreviewLayoutLinesTool.cpp
MaskEditorPanel.cpp MaskImageCtrl.cpp MaskLoadDialog.cpp)

set(hugin_HEADERS
huginApp.h ImagesList.h AutoCtrlPointCreator.h CPDetectorConfig.h CPDetectorConfig_default.h
MainFrame.h CPImageCtrl.h CPImagesComboBox.h CPEditorPanel.h LensPanel.h 
ImagesPanel.h CommandHistory.h PanoPanel.h NonaOptionsDialog.h HDRMergeOptionDialog.h
PreviewFrame.h PreviewPanel.h GLPreviewFrame.h GLViewer.h GLRenderer.h NumTransDialog.h
CropPanel.h OptimizePhotometricPanel.h OptimizePanel.h CPListFrame.h
TextKillFocusHandler.h PreferencesDialog.h ResetDialog.h
LocalizedFileTipProvider.h  wxPanoCommand.h AssistantPanel.h
HFOVDialog.h TextureManager.h MeshRemapper.h VertexCoordRemapper.h
TexCoordRemapper.h ChoosyRemapper.h MeshManager.h ViewState.h
OutputProjectionInfo.h PreviewToolHelper.h PreviewTool.h 
PreviewCropTool.h PreviewDragTool.h PreviewIdentifyTool.h
PreviewDifferenceTool.h PreviewPanoMaskTool.h PreviewControlPointTool.h
GreatCircles.h AboutDialog.h LayoutRemapper.h PreviewLayoutLinesTool.h
MaskEditorPanel.h MaskImageCtrl.h MaskLoadDialog.h)

IF(APPLE)
  if (MAC_SELF_CONTAINED_BUNDLE)
    MESSAGE("TODO: MAC_SELF_CONTAINED_BUNDLE currently broken")
    FILE(GLOB TRANSLATION_FILES ${CMAKE_CURRENT_BINARY_DIR}/po/*.lproj/locale/hugin.mo)
    FILE(GLOB_RECURSE XRC_FILES ${CMAKE_CURRENT_SOURCE_DIR}/xrc/*.html 
      		    	        ${CMAKE_CURRENT_SOURCE_DIR}/xrc/*.htm
  			        ${CMAKE_CURRENT_SOURCE_DIR}/xrc/*.hhc
			        ${CMAKE_CURRENT_SOURCE_DIR}/xrc/*.hhk	
			        ${CMAKE_CURRENT_SOURCE_DIR}/xrc/*.hhp
			        ${CMAKE_CURRENT_SOURCE_DIR}/xrc/*.xrc
			        ${CMAKE_CURRENT_SOURCE_DIR}/xrc/*.ico
			        ${CMAKE_CURRENT_SOURCE_DIR}/xrc/*.jpg
			        ${CMAKE_CURRENT_SOURCE_DIR}/xrc/*.png
			        ${CMAKE_CURRENT_SOURCE_DIR}/xrc/*.txt
			        ${CMAKE_CURRENT_SOURCE_DIR}/xrc/*.mk
			        ${CMAKE_CURRENT_SOURCE_DIR}/xrc/*.pl)

    set( ICON_FILES ${MACOSX_BUNDLE_ICON_FILE} ${MACOSX_BUNDLE_TYPE_ICON_FILE} )
	
    ADD_EXECUTABLE( ${PROGNAME} MACOSX_BUNDLE ${hugin_SOURCES} 
  		    ${ICON_FILES} ${TRANSLATION_FILES} ${XRC_FILES} )

    FOREACH(_file ${TRANSLATION_FILES})
          GET_FILENAME_COMPONENT(_file_dir ${_file} PATH)
	  FILE(RELATIVE_PATH _file_dir ${CMAKE_CURRENT_BINARY_DIR}/po ${_file_dir})
	  SET_SOURCE_FILES_PROPERTIES( ${_file} PROPERTIES 
				       MACOSX_PACKAGE_LOCATION 
				       "Resources/${_file_dir}" )
    ENDFOREACH(_file)

    FOREACH(_file ${XRC_FILES})
          GET_FILENAME_COMPONENT(_file_dir ${_file} PATH)
	  FILE(RELATIVE_PATH _file_dir ${CMAKE_CURRENT_SOURCE_DIR} ${_file_dir})
	  SET_SOURCE_FILES_PROPERTIES( ${_file} PROPERTIES 
				      MACOSX_PACKAGE_LOCATION 
				      "Resources/${_file_dir}")
    ENDFOREACH(_file)

    #ADD_CUSTOM_COMMAND( 
    #  TARGET ${PROGNAME}
    #  POST_BUILD
    #  COMMAND ${CMAKE_COMMAND}
    #  ARGS -Dfile="${CMAKE_CURRENT_BINARY_DIR}/${PROGNAME}.app/Contents/Resources/xrc/cp_editor_panel.xrc" -P ${CMAKE_SOURCE_DIR}/CMakeModules/fix_osx_xrc.cmake
    #)

  else (MAC_SELF_CONTAINED_BUNDLE)

    # bare bones bundle, with only hugin inside, all other ressources outside.
    set( ICON_FILES ${MACOSX_BUNDLE_ICON_FILE} ${MACOSX_BUNDLE_TYPE_ICON_FILE} )
    ADD_EXECUTABLE( ${PROGNAME} MACOSX_BUNDLE ${hugin_SOURCES} 
  		    ${ICON_FILES})

  endif (MAC_SELF_CONTAINED_BUNDLE)

  SET_SOURCE_FILES_PROPERTIES(
  	${ICON_FILES}
  	PROPERTIES 
	MACOSX_PACKAGE_LOCATION Resources)

ELSEIF ( WIN32 )
  ADD_EXECUTABLE( ${PROGNAME} WIN32 ${hugin_SOURCES} ${hugin_HEADERS} hugin_rc.rc )
ELSE (APPLE)
  ADD_EXECUTABLE( ${PROGNAME} ${hugin_SOURCES} ${hugin_HEADERS})
ENDIF(APPLE)

target_link_libraries( ${PROGNAME} ${common_libs} ${image_libs} huginbasewx celeste ${wxWidgets_LIBRARIES} ${OPENGL_LIBRARIES} ${GLEW_LIBRARIES} ${GLUT_LIBRARIES})

IF (APPLE)
  IF (NOT MAC_SELF_CONTAINED_BUNDLE)
    install(TARGETS ${PROGNAME}
            DESTINATION ${INSTALL_OSX_BUNDLE_DIR})
  ELSE (NOT MAC_SELF_CONTAINED_BUNDLE)
    # try to build selfcontained bundle
    INCLUDE (${CMAKE_SOURCE_DIR}/CMakeModules/AppleRELEASEOptions.cmake)
  ENDIF (NOT MAC_SELF_CONTAINED_BUNDLE)
ELSE(APPLE)
  install(TARGETS ${PROGNAME}
          DESTINATION ${BINDIR})
  IF(UNIX)
    # install further stuff (icons etc.)
    INSTALL(FILES hugin.desktop DESTINATION ${DATADIR}/applications)
    INSTALL(FILES gnome-mime-application-x-ptoptimizer-script.png DESTINATION ${DATADIR}/icons/gnome/48x48/mimetypes)
    INSTALL(FILES hugin.xml DESTINATION ${DATADIR}/mime/packages)
    INSTALL(FILES Makefile.equirect.mk DESTINATION ${HUGINDATADIR})
  ENDIF(UNIX)
ENDIF(APPLE)

add_subdirectory(xrc)

=== debian/changelog ===
hugin (2010.2.0+dfsg~rc2-1ubuntu1) natty; urgency=low

  * Merge from debian unstable.  Remaining changes:
    - debian/control: Add depends on autopano-sift-c | autopano-sift
    - Rework 51_ubuntu-autopano-sift.patch

 -- Fabrice Coutadeur <fabricesp@ubuntu.com>  Mon, 08 Nov 2010 06:28:47 +0000

hugin (2010.2.0+dfsg~rc2-1) experimental; urgency=low

  * New upstream version.
  * Bump build-dep on libpano13 to require 2.9.17 release.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 02 Oct 2010 13:57:01 +0200

hugin (2010.2.0+dfsg~rc1-1) experimental; urgency=low

  * New upstream version.
  * Standards-Version 3.9.1. No changes required.
  * Wrap Build-Depends line in debian/control

 -- Andreas Metzler <ametzler@debian.org>  Sat, 18 Sep 2010 12:16:40 +0200

hugin (2010.2.0+dfsg~beta2-1) experimental; urgency=low

  * New upstream version.

 -- Andreas Metzler <ametzler@debian.org>  Wed, 01 Sep 2010 18:59:01 +0200

hugin (2010.2.0+dfsg~beta1-1) experimental; urgency=low

  * New upstream version.
    + Drop debian/patches/20_readonly_fs.diff, included upstream.
    + Update patches.
    + Bump build-dep on libpano13-dev to (>= 2.9.17~beta2-0).
  * Ship newly available binaries (pano_modify pano_trafo pto_merge).

 -- Andreas Metzler <ametzler@debian.org>  Sun, 18 Jul 2010 18:15:48 +0200

=== debian/control ===
Source: hugin
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Cyril Brulebois <kibi@debian.org>, Florent Bayle <fbayle@bigfoot.com>, Andreas Metzler <ametzler@debian.org>
Build-Depends: debhelper (>= 5), cmake, libboost-graph-dev,
 libboost-thread-dev, zlib1g-dev, libexiv2-dev (>= 0.12), libjpeg62-dev,
 libopenexr-dev, libpano13-dev (>= 2.9.17-0), libpng12-dev,
 libtiff4-dev, libgtk2.0-dev, libwxgtk2.8-dev, libglew1.5-dev, freeglut3-dev
Build-Conflicts: wx2.6-headers
Standards-Version: 3.9.1
Homepage: http://hugin.sourceforge.net/
Vcs-Git: git://git.debian.org/git/pkg-phototools/hugin.git
Vcs-Browser: http://git.debian.org/?p=pkg-phototools/hugin.git

Package: hugin
Section: graphics
Architecture: any
Depends: hugin-tools (= ${binary:Version}), enblend (>= 3.2), enfuse, libimage-exiftool-perl, make, autopano-sift-c | autopano-sift , ${shlibs:Depends}, ${misc:Depends}
Conflicts: hugin-bin (<< 0.7.0~svn)
Replaces: hugin-bin (<< 0.7.0~svn), hugin-data (<< 0.7.0~svn), hugin-tools (<< 0.7.0~svn)
Provides: hugin-bin
Description: GUI tools for Hugin
 Hugin is a panorama photo stitching program. Essentially, Hugin is a
 GUI frontend for Panorama Tools. Stitching is accomplished by using
 several overlapping photos taken from the same location, and using
 control points to align and transform the photos so that they can be
 blended together to form a larger image. Hugin allows for the easy
 creation of control points between two images, optimization of the
 image transforms, and much more.
 .
 This package includes the following graphical interfaces, using the
 command-line tools provided in the hugin-tools package:
  * hugin                - Hugin panorama creator
  * hugin_stitch_project - Hugin batch stitcher
  * nona_gui             - Graphical interface for nona.

Package: hugin-tools
Section: graphics
Architecture: any
Depends: hugin-data (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Conflicts: hugin-bin (<< 0.7.0~svn)
Replaces: hugin-bin (<< 0.7.0~svn)
Recommends: libpano13-bin
Suggests: autopano-sift | autopano-sift-c
Description: CLI tools for Hugin
 Hugin is a panorama photo stitching program.
 .
 This package includes command-line tools used by hugin and other
 packages for image stitching and High Dynamic Range (HDR) images:
  * align_image_stack - Align overlapping images for HDR creation.
  * autooptimiser     - Optimize image positions.
  * calibrate_lens    - Lens calibration tool
  * cpclean           - Remove wrong control points
  * fulla             - Correct lens distortion, vignetting, and
                        chromatic aberration.
  * hugin_hdrmerge    - Merge overlapping images.
  * nona              - Stitch a panorama image.
  * vig_optimize      - Determine the radial vignetting.
  * pto2mk            - Create a makefile for stitching.
  * matchpoint        - Run feature detection and extraction
  * celeste_standalone- Remove cloud-like control points.

Package: hugin-data
Section: graphics
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: data files for Hugin
 Hugin is a panorama photo stitching program.
 .
 This package includes the data files needed by the hugin and
 hugin-tools packages.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

BUILD_DIR=build-dir

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

LDFLAGS=-Wl,--as-needed -Wl,-z,defs
CMAKE_LDFLAGS=-DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)" -DCMAKE_MODULE_LINKER_FLAGS="$(LDFLAGS)" -DCMAKE_SHARED_LINKER_FLAGS="$(LDFLAGS)"

# Upstream version can be overriden so as to fetch newer revisions
# without having to modify the top-most changelog entry
UVERSION  ?= $(shell dpkg-parsechangelog | perl -ne 'print "$$1\n" if (/^Version: (.*?)(?:\.dfsg)?\-.*?$$/)')
UREVISION  = $(shell echo $(UVERSION) | sed -e 's/^.*svn//')
UTRUNK     = https://hugin.svn.sourceforge.net/svnroot/hugin/hugin/trunk

# Where to store which manpages are generated (upstream keeps some manpages
# both under .pod and .1 formats).
GENERATED_MANPAGES=debian/generated-manpages

maint-svn-snapshot:
	@echo "Latest trunk:      $(shell LANG=C svn info $(UTRUNK) | grep Revision | awk -F": " '{print $$2}')"
	@echo "Upstream version:  $(UVERSION)"
	@echo "Upstream revision: $(UREVISION)"
	[ ! -f ../hugin_$(UVERSION).orig.tar.gz ] || (echo "Upstream tarball exists already. Aborting."; exit 1)
	svn export -q -r $(UREVISION) $(UTRUNK) debian/svn/hugin-$(UVERSION)
	tar cfz ../hugin_$(UVERSION).orig.tar.gz -C debian/svn hugin-$(UVERSION)
	echo "../hugin_$(UVERSION).orig.tar.gz ready"
	rm -rf debian/svn

configure-stamp:
	dh_testdir
	# Configure the package.
	mkdir $(BUILD_DIR)
	cd $(BUILD_DIR) && cmake -DCMAKE_INSTALL_PREFIX=/usr $(CMAKE_LDFLAGS) ..
	touch $@


build: build-arch build-indep

build-arch:  build-arch-stamp
build-indep: build-indep-stamp

build-arch-stamp: configure-stamp
	# Compile the package.
	$(MAKE) -C $(BUILD_DIR) VERBOSE=1
	touch $@

build-indep-stamp: configure-stamp
	# Build manpages.
	for i in doc/*.pod ; do \
		if [ ! -f $${i%%.pod}.1 ] ; then \
			pod2man --center "HUGIN TOOLS" \
				--release $(UVERSION) \
				$$i -o $${i%%.pod}.1 ; \
			echo $${i%%.pod}.1 >> $(GENERATED_MANPAGES) ; \
		fi ; \
	done
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-indep-stamp build-arch-stamp install-arch-stamp \
		install-indep-stamp configure-stamp src/celeste/Config.h

	# Clean up after the build process.
	rm -rf $(BUILD_DIR)

	# Clean generated manpages.
	if [ -f $(GENERATED_MANPAGES) ] ; then \
		for i in `cat $(GENERATED_MANPAGES)` ; do \
			rm -f $$i ; \
		done ; \
	fi
	rm -f $(GENERATED_MANPAGES)

	dh_clean

install: install-indep install-arch

install-indep: install-indep-stamp
install-arch: install-arch-stamp

install-indep-stamp: build-indep-stamp install-arch-stamp
	dh_testdir
	dh_testroot
	dh_installdirs -i

	dh_install --sourcedir=debian/tmp -i
	touch $@

install-arch-stamp: build-arch-stamp
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs -a

	# Install the package into debian/tmp.
	$(MAKE) install -C $(BUILD_DIR) DESTDIR=$(CURDIR)/debian/tmp

	# Get rid of extra license file
	rm debian/tmp/usr/share/hugin/xrc/data/help_en_EN/LICENCE.manual

	# Get rid of .so, which aren't actually needed
	find debian/tmp -name '*.so' -delete

	dh_install --sourcedir=debian/tmp -a
	touch $@

binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
	dh_installmenu
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common

get-orig-source:
	rm -rf  $(CURDIR)/debian/get-orig-source
	mkdir $(CURDIR)/debian/get-orig-source
	uscan --force-download --rename --download-version ${UVERSION} \
		--destdir $(CURDIR)/debian/get-orig-source
	cd $(CURDIR)/debian/get-orig-source && \
		if test -e hugin_${UVERSION}.orig.tar.gz ; then \
		tar xzf hugin_${UVERSION}.orig.tar.gz ; else \
		tar xjf hugin_${UVERSION}.orig.tar.bz2 ; fi && \
		cd hugin-* && \
		rm -rvf platforms/windows/ mac/*  \
		src/foreign/getopt/src/msvs/ platforms/mac/* \
		platforms/CMakeLists.txt &&\
		touch platforms/CMakeLists.txt && \
		cd .. && \
		tar -czf $(CURDIR)/../hugin_$(UVERSION).dfsg.orig.tar.gz hugin-*
	rm -rf  $(CURDIR)/debian/get-orig-source


binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch get-orig-source
